/* dialog.c generated by valac 0.56.18, the Vala compiler
 * generated from dialog.vala, do not modify */

/* -*- Mode: vala; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*-
 *
 * Copyright © 2014 Nikhar Agrawal
 *
 * This file is part of libgnome-games-support.
 *
 * libgnome-games-support is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libgnome-games-support is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with libgnome-games-support.  If not, see <http://www.gnu.org/licenses/>.
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include "libgnome-games-support.h"
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <gee.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

#define GAMES_SCORES_TYPE_DIALOG (games_scores_dialog_get_type ())
#define GAMES_SCORES_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), GAMES_SCORES_TYPE_DIALOG, GamesScoresDialog))
#define GAMES_SCORES_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), GAMES_SCORES_TYPE_DIALOG, GamesScoresDialogClass))
#define GAMES_SCORES_IS_DIALOG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), GAMES_SCORES_TYPE_DIALOG))
#define GAMES_SCORES_IS_DIALOG_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), GAMES_SCORES_TYPE_DIALOG))
#define GAMES_SCORES_DIALOG_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), GAMES_SCORES_TYPE_DIALOG, GamesScoresDialogClass))

typedef struct _GamesScoresDialog GamesScoresDialog;
typedef struct _GamesScoresDialogClass GamesScoresDialogClass;
typedef struct _GamesScoresDialogPrivate GamesScoresDialogPrivate;
enum  {
	GAMES_SCORES_DIALOG_0_PROPERTY,
	GAMES_SCORES_DIALOG_NUM_PROPERTIES
};
static GParamSpec* games_scores_dialog_properties[GAMES_SCORES_DIALOG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block4Data Block4Data;
typedef struct _Block5Data Block5Data;

struct _GamesScoresDialog {
	GtkDialog parent_instance;
	GamesScoresDialogPrivate * priv;
};

struct _GamesScoresDialogClass {
	GtkDialogClass parent_class;
};

struct _GamesScoresDialogPrivate {
	GamesScoresContext* context;
	GamesScoresCategory* active_category;
	gint rows_to_display;
	GtkComboBoxText* combo;
	GtkLabel* category_label;
	GtkHeaderBar* headerbar;
	GtkGrid* grid;
	GamesScoresStyle scores_style;
	GamesScoresScore* new_high_score;
	GamesScoresCategory* scores_active_category;
};

struct _Block4Data {
	int _ref_count_;
	GamesScoresDialog* self;
	GamesScoresScore* score;
};

struct _Block5Data {
	int _ref_count_;
	Block4Data * _data4_;
	GtkEntry* entry;
};

static gint GamesScoresDialog_private_offset;
static gpointer games_scores_dialog_parent_class = NULL;

VALA_EXTERN GType games_scores_dialog_get_type (void) G_GNUC_CONST ;
VALA_EXTERN GamesScoresDialog* games_scores_dialog_new (GamesScoresContext* context,
                                            const gchar* category_type,
                                            GamesScoresStyle style,
                                            GamesScoresScore* new_high_score,
                                            GamesScoresCategory* current_cat,
                                            GtkWindow* window,
                                            const gchar* icon_name);
VALA_EXTERN GamesScoresDialog* games_scores_dialog_construct (GType object_type,
                                                  GamesScoresContext* context,
                                                  const gchar* category_type,
                                                  GamesScoresStyle style,
                                                  GamesScoresScore* new_high_score,
                                                  GamesScoresCategory* current_cat,
                                                  GtkWindow* window,
                                                  const gchar* icon_name);
VALA_EXTERN GList* games_scores_context_get_categories (GamesScoresContext* self);
static void games_scores_dialog_load_scores (GamesScoresDialog* self);
static void _games_scores_dialog_load_scores_gtk_combo_box_changed (GtkComboBox* _sender,
                                                             gpointer self);
static void games_scores_dialog_fill_grid_with_labels (GamesScoresDialog* self);
static void games_scores_dialog_load_categories (GamesScoresDialog* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static void __lambda10_ (GamesScoresDialog* self,
                  GamesScoresCategory* x);
static void ___lambda10__gfunc (gconstpointer data,
                         gpointer self);
static void games_scores_dialog_display_single_score (GamesScoresDialog* self,
                                               GamesScoresScore* score,
                                               gint row_count,
                                               guint no_scores);
static void games_scores_dialog_make_remaining_labels_empty (GamesScoresDialog* self,
                                                      gint row_count);
static Block4Data* block4_data_ref (Block4Data* _data4_);
static void block4_data_unref (void * _userdata_);
static Block5Data* block5_data_ref (Block5Data* _data5_);
static void block5_data_unref (void * _userdata_);
static void ___lambda9_ (Block5Data* _data5_);
VALA_EXTERN void games_scores_context_update_score_name (GamesScoresContext* self,
                                             GamesScoresScore* old_score,
                                             GamesScoresCategory* category,
                                             const gchar* new_name);
static void ____lambda9__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static void games_scores_dialog_finalize (GObject * obj);
static GType games_scores_dialog_get_type_once (void);

static inline gpointer
games_scores_dialog_get_instance_private (GamesScoresDialog* self)
{
	return G_STRUCT_MEMBER_P (self, GamesScoresDialog_private_offset);
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 45 "../games/scores/dialog.vala"
	return self ? g_object_ref (self) : NULL;
#line 160 "dialog.c"
}

static void
_games_scores_dialog_load_scores_gtk_combo_box_changed (GtkComboBox* _sender,
                                                        gpointer self)
{
#line 130 "../games/scores/dialog.vala"
	games_scores_dialog_load_scores ((GamesScoresDialog*) self);
#line 169 "dialog.c"
}

static void
_g_object_unref0_ (gpointer var)
{
#line 39 "../games/scores/dialog.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 177 "dialog.c"
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 39 "../games/scores/dialog.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 185 "dialog.c"
}

GamesScoresDialog*
games_scores_dialog_construct (GType object_type,
                               GamesScoresContext* context,
                               const gchar* category_type,
                               GamesScoresStyle style,
                               GamesScoresScore* new_high_score,
                               GamesScoresCategory* current_cat,
                               GtkWindow* window,
                               const gchar* icon_name)
{
	GamesScoresDialog * self = NULL;
	GamesScoresContext* _tmp0_;
	GamesScoresScore* _tmp1_;
	GamesScoresCategory* _tmp2_;
	GtkHeaderBar* _tmp3_;
	GtkHeaderBar* _tmp4_;
	GtkHeaderBar* _tmp5_;
	GtkBox* vbox = NULL;
	GtkBox* _tmp10_;
	GtkBox* _tmp11_;
	GtkBox* _tmp12_;
	gboolean _tmp13_ = FALSE;
	GtkBox* _tmp41_;
	GtkBox* catbar = NULL;
	GtkBox* _tmp42_;
	GtkBox* _tmp43_;
	GtkBox* _tmp44_;
	GtkBox* _tmp45_;
	GtkBox* _tmp46_;
	GtkBox* _tmp47_;
	GtkBox* _tmp48_;
	GtkSeparator* hdiv = NULL;
	GtkSeparator* _tmp49_;
	GtkBox* _tmp50_;
	GtkSeparator* _tmp51_;
	GtkLabel* label = NULL;
	GtkLabel* _tmp52_;
	GtkLabel* _tmp53_;
	GtkLabel* _tmp54_;
	GtkBox* _tmp55_;
	GtkLabel* _tmp56_;
	GList* categories = NULL;
	GList* _tmp57_;
	gboolean _tmp58_ = FALSE;
	GtkGrid* _tmp78_;
	GtkBox* _tmp79_;
	GtkGrid* _tmp80_;
	GtkGrid* _tmp81_;
	GtkGrid* _tmp82_;
	GtkGrid* _tmp83_;
	GtkGrid* _tmp84_;
	GtkGrid* _tmp85_;
	GtkGrid* _tmp86_;
	gchar* string_rank = NULL;
	gchar* _tmp87_;
	GtkLabel* label_column_1 = NULL;
	const gchar* _tmp88_;
	gchar* _tmp89_;
	gchar* _tmp90_;
	gchar* _tmp91_;
	gchar* _tmp92_;
	GtkLabel* _tmp93_;
	GtkLabel* _tmp94_;
	GtkLabel* _tmp95_;
	GtkGrid* _tmp96_;
	GtkLabel* _tmp97_;
	gchar* score_or_time = NULL;
	gchar* _tmp98_;
	gboolean _tmp99_ = FALSE;
	GtkLabel* label_column_2 = NULL;
	const gchar* _tmp102_;
	gchar* _tmp103_;
	gchar* _tmp104_;
	gchar* _tmp105_;
	gchar* _tmp106_;
	GtkLabel* _tmp107_;
	GtkLabel* _tmp108_;
	GtkLabel* _tmp109_;
	GtkGrid* _tmp110_;
	GtkLabel* _tmp111_;
	gchar* string_player = NULL;
	gchar* _tmp112_;
	GtkLabel* label_column_3 = NULL;
	const gchar* _tmp113_;
	gchar* _tmp114_;
	gchar* _tmp115_;
	gchar* _tmp116_;
	gchar* _tmp117_;
	GtkLabel* _tmp118_;
	GtkLabel* _tmp119_;
	GtkLabel* _tmp120_;
	GtkGrid* _tmp121_;
	GtkLabel* _tmp122_;
	GtkGrid* _tmp123_;
	GtkBox* _tmp126_;
#line 39 "../games/scores/dialog.vala"
	g_return_val_if_fail (context != NULL, NULL);
#line 39 "../games/scores/dialog.vala"
	g_return_val_if_fail (category_type != NULL, NULL);
#line 39 "../games/scores/dialog.vala"
	g_return_val_if_fail (window != NULL, NULL);
#line 39 "../games/scores/dialog.vala"
	g_return_val_if_fail (icon_name != NULL, NULL);
#line 41 "../games/scores/dialog.vala"
	self = (GamesScoresDialog*) g_object_new (object_type, "use-header-bar", 1, NULL);
#line 43 "../games/scores/dialog.vala"
	gtk_window_set_resizable ((GtkWindow*) self, FALSE);
#line 45 "../games/scores/dialog.vala"
	_tmp0_ = _g_object_ref0 (context);
#line 45 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->context);
#line 45 "../games/scores/dialog.vala"
	self->priv->context = _tmp0_;
#line 46 "../games/scores/dialog.vala"
	gtk_window_set_transient_for ((GtkWindow*) self, window);
#line 47 "../games/scores/dialog.vala"
	_tmp1_ = _g_object_ref0 (new_high_score);
#line 47 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->new_high_score);
#line 47 "../games/scores/dialog.vala"
	self->priv->new_high_score = _tmp1_;
#line 49 "../games/scores/dialog.vala"
	self->priv->scores_style = style;
#line 50 "../games/scores/dialog.vala"
	_tmp2_ = _g_object_ref0 (current_cat);
#line 50 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->scores_active_category);
#line 50 "../games/scores/dialog.vala"
	self->priv->scores_active_category = _tmp2_;
#line 52 "../games/scores/dialog.vala"
	_tmp3_ = gtk_dialog_get_header_bar ((GtkDialog*) self);
#line 52 "../games/scores/dialog.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, gtk_header_bar_get_type (), GtkHeaderBar));
#line 52 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 52 "../games/scores/dialog.vala"
	self->priv->headerbar = _tmp4_;
#line 54 "../games/scores/dialog.vala"
	_tmp5_ = self->priv->headerbar;
#line 54 "../games/scores/dialog.vala"
	gtk_header_bar_set_show_close_button (_tmp5_, new_high_score == NULL);
#line 56 "../games/scores/dialog.vala"
	if (new_high_score != NULL) {
#line 331 "dialog.c"
		GtkHeaderBar* _tmp6_;
#line 58 "../games/scores/dialog.vala"
		_tmp6_ = self->priv->headerbar;
#line 58 "../games/scores/dialog.vala"
		gtk_header_bar_set_title (_tmp6_, _ ("Congratulations!"));
#line 337 "dialog.c"
	} else {
		gboolean _tmp7_ = FALSE;
#line 59 "../games/scores/dialog.vala"
		if (self->priv->scores_style == GAMES_SCORES_STYLE_POINTS_GREATER_IS_BETTER) {
#line 59 "../games/scores/dialog.vala"
			_tmp7_ = TRUE;
#line 344 "dialog.c"
		} else {
#line 59 "../games/scores/dialog.vala"
			_tmp7_ = self->priv->scores_style == GAMES_SCORES_STYLE_POINTS_LESS_IS_BETTER;
#line 348 "dialog.c"
		}
#line 59 "../games/scores/dialog.vala"
		if (_tmp7_) {
#line 352 "dialog.c"
			GtkHeaderBar* _tmp8_;
#line 60 "../games/scores/dialog.vala"
			_tmp8_ = self->priv->headerbar;
#line 60 "../games/scores/dialog.vala"
			gtk_header_bar_set_title (_tmp8_, _ ("High Scores"));
#line 358 "dialog.c"
		} else {
			GtkHeaderBar* _tmp9_;
#line 62 "../games/scores/dialog.vala"
			_tmp9_ = self->priv->headerbar;
#line 62 "../games/scores/dialog.vala"
			gtk_header_bar_set_title (_tmp9_, _ ("Best Times"));
#line 365 "dialog.c"
		}
	}
#line 64 "../games/scores/dialog.vala"
	_tmp10_ = gtk_dialog_get_content_area ((GtkDialog*) self);
#line 64 "../games/scores/dialog.vala"
	_tmp11_ = _g_object_ref0 (_tmp10_);
#line 64 "../games/scores/dialog.vala"
	vbox = _tmp11_;
#line 65 "../games/scores/dialog.vala"
	_tmp12_ = vbox;
#line 65 "../games/scores/dialog.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp12_, GTK_ORIENTATION_VERTICAL);
#line 67 "../games/scores/dialog.vala"
	if (!games_scores_context_has_scores (context)) {
#line 67 "../games/scores/dialog.vala"
		_tmp13_ = new_high_score == NULL;
#line 382 "dialog.c"
	} else {
#line 67 "../games/scores/dialog.vala"
		_tmp13_ = FALSE;
#line 386 "dialog.c"
	}
#line 67 "../games/scores/dialog.vala"
	if (_tmp13_) {
#line 390 "dialog.c"
		GtkBox* _tmp14_;
		GtkBox* _tmp15_;
		GtkBox* _tmp16_;
		GtkBox* _tmp17_;
		GtkBox* _tmp18_;
		GtkStyleContext* _tmp19_;
		GtkImage* image = NULL;
		GtkImage* _tmp20_;
		GtkImage* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		GtkImage* _tmp24_;
		GtkImage* _tmp25_;
		GtkBox* _tmp26_;
		GtkImage* _tmp27_;
		GtkLabel* title_label = NULL;
		gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		GtkLabel* _tmp32_;
		GtkLabel* _tmp33_;
		GtkLabel* _tmp34_;
		GtkBox* _tmp35_;
		GtkLabel* _tmp36_;
		GtkLabel* description_label = NULL;
		GtkLabel* _tmp37_;
		GtkBox* _tmp38_;
		GtkLabel* _tmp39_;
		GtkBox* _tmp40_;
#line 69 "../games/scores/dialog.vala"
		_tmp14_ = vbox;
#line 69 "../games/scores/dialog.vala"
		gtk_box_set_spacing (_tmp14_, 4);
#line 70 "../games/scores/dialog.vala"
		_tmp15_ = vbox;
#line 70 "../games/scores/dialog.vala"
		gtk_widget_set_hexpand ((GtkWidget*) _tmp15_, TRUE);
#line 71 "../games/scores/dialog.vala"
		_tmp16_ = vbox;
#line 71 "../games/scores/dialog.vala"
		gtk_widget_set_vexpand ((GtkWidget*) _tmp16_, TRUE);
#line 72 "../games/scores/dialog.vala"
		_tmp17_ = vbox;
#line 72 "../games/scores/dialog.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp17_, GTK_ALIGN_CENTER);
#line 73 "../games/scores/dialog.vala"
		_tmp18_ = vbox;
#line 73 "../games/scores/dialog.vala"
		_tmp19_ = gtk_widget_get_style_context ((GtkWidget*) _tmp18_);
#line 73 "../games/scores/dialog.vala"
		gtk_style_context_add_class (_tmp19_, "dim-label");
#line 75 "../games/scores/dialog.vala"
		_tmp20_ = (GtkImage*) gtk_image_new ();
#line 75 "../games/scores/dialog.vala"
		g_object_ref_sink (_tmp20_);
#line 75 "../games/scores/dialog.vala"
		image = _tmp20_;
#line 76 "../games/scores/dialog.vala"
		_tmp21_ = image;
#line 76 "../games/scores/dialog.vala"
		_tmp22_ = g_strconcat (icon_name, "-symbolic", NULL);
#line 76 "../games/scores/dialog.vala"
		_tmp23_ = _tmp22_;
#line 76 "../games/scores/dialog.vala"
		g_object_set (_tmp21_, "icon-name", _tmp23_, NULL);
#line 76 "../games/scores/dialog.vala"
		_g_free0 (_tmp23_);
#line 77 "../games/scores/dialog.vala"
		_tmp24_ = image;
#line 77 "../games/scores/dialog.vala"
		gtk_image_set_pixel_size (_tmp24_, 64);
#line 78 "../games/scores/dialog.vala"
		_tmp25_ = image;
#line 78 "../games/scores/dialog.vala"
		gtk_widget_set_opacity ((GtkWidget*) _tmp25_, 0.2);
#line 79 "../games/scores/dialog.vala"
		_tmp26_ = vbox;
#line 79 "../games/scores/dialog.vala"
		_tmp27_ = image;
#line 79 "../games/scores/dialog.vala"
		gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
#line 81 "../games/scores/dialog.vala"
		_tmp28_ = g_strconcat ("<b><span size=\"large\">", _ ("No scores yet"), NULL);
#line 81 "../games/scores/dialog.vala"
		_tmp29_ = _tmp28_;
#line 81 "../games/scores/dialog.vala"
		_tmp30_ = g_strconcat (_tmp29_, "</span></b>", NULL);
#line 81 "../games/scores/dialog.vala"
		_tmp31_ = _tmp30_;
#line 81 "../games/scores/dialog.vala"
		_tmp32_ = (GtkLabel*) gtk_label_new (_tmp31_);
#line 81 "../games/scores/dialog.vala"
		g_object_ref_sink (_tmp32_);
#line 81 "../games/scores/dialog.vala"
		_tmp33_ = _tmp32_;
#line 81 "../games/scores/dialog.vala"
		_g_free0 (_tmp31_);
#line 81 "../games/scores/dialog.vala"
		_g_free0 (_tmp29_);
#line 81 "../games/scores/dialog.vala"
		title_label = _tmp33_;
#line 82 "../games/scores/dialog.vala"
		_tmp34_ = title_label;
#line 82 "../games/scores/dialog.vala"
		gtk_label_set_use_markup (_tmp34_, TRUE);
#line 83 "../games/scores/dialog.vala"
		_tmp35_ = vbox;
#line 83 "../games/scores/dialog.vala"
		_tmp36_ = title_label;
#line 83 "../games/scores/dialog.vala"
		gtk_container_add ((GtkContainer*) _tmp35_, (GtkWidget*) _tmp36_);
#line 85 "../games/scores/dialog.vala"
		_tmp37_ = (GtkLabel*) gtk_label_new (_ ("Play some games and your scores will show up here."));
#line 85 "../games/scores/dialog.vala"
		g_object_ref_sink (_tmp37_);
#line 85 "../games/scores/dialog.vala"
		description_label = _tmp37_;
#line 86 "../games/scores/dialog.vala"
		_tmp38_ = vbox;
#line 86 "../games/scores/dialog.vala"
		_tmp39_ = description_label;
#line 86 "../games/scores/dialog.vala"
		gtk_container_add ((GtkContainer*) _tmp38_, (GtkWidget*) _tmp39_);
#line 88 "../games/scores/dialog.vala"
		_tmp40_ = vbox;
#line 88 "../games/scores/dialog.vala"
		gtk_widget_show_all ((GtkWidget*) _tmp40_);
#line 90 "../games/scores/dialog.vala"
		g_object_set ((GtkWidget*) self, "width-request", 450, NULL);
#line 91 "../games/scores/dialog.vala"
		g_object_set ((GtkWidget*) self, "height-request", 500, NULL);
#line 93 "../games/scores/dialog.vala"
		_g_object_unref0 (description_label);
#line 93 "../games/scores/dialog.vala"
		_g_object_unref0 (title_label);
#line 93 "../games/scores/dialog.vala"
		_g_object_unref0 (image);
#line 93 "../games/scores/dialog.vala"
		_g_object_unref0 (vbox);
#line 93 "../games/scores/dialog.vala"
		return self;
#line 533 "dialog.c"
	}
#line 96 "../games/scores/dialog.vala"
	_tmp41_ = vbox;
#line 96 "../games/scores/dialog.vala"
	gtk_box_set_spacing (_tmp41_, 20);
#line 98 "../games/scores/dialog.vala"
	_tmp42_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 12);
#line 98 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp42_);
#line 98 "../games/scores/dialog.vala"
	catbar = _tmp42_;
#line 99 "../games/scores/dialog.vala"
	_tmp43_ = catbar;
#line 99 "../games/scores/dialog.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp43_, 20);
#line 100 "../games/scores/dialog.vala"
	_tmp44_ = catbar;
#line 100 "../games/scores/dialog.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp44_, 20);
#line 101 "../games/scores/dialog.vala"
	_tmp45_ = catbar;
#line 101 "../games/scores/dialog.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp45_, 20);
#line 102 "../games/scores/dialog.vala"
	_tmp46_ = catbar;
#line 102 "../games/scores/dialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp46_, GTK_ALIGN_CENTER);
#line 104 "../games/scores/dialog.vala"
	_tmp47_ = vbox;
#line 104 "../games/scores/dialog.vala"
	_tmp48_ = catbar;
#line 104 "../games/scores/dialog.vala"
	gtk_container_add ((GtkContainer*) _tmp47_, (GtkWidget*) _tmp48_);
#line 106 "../games/scores/dialog.vala"
	_tmp49_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
#line 106 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp49_);
#line 106 "../games/scores/dialog.vala"
	hdiv = _tmp49_;
#line 107 "../games/scores/dialog.vala"
	_tmp50_ = vbox;
#line 107 "../games/scores/dialog.vala"
	_tmp51_ = hdiv;
#line 107 "../games/scores/dialog.vala"
	gtk_container_add ((GtkContainer*) _tmp50_, (GtkWidget*) _tmp51_);
#line 109 "../games/scores/dialog.vala"
	_tmp52_ = (GtkLabel*) gtk_label_new (category_type);
#line 109 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp52_);
#line 109 "../games/scores/dialog.vala"
	label = _tmp52_;
#line 110 "../games/scores/dialog.vala"
	_tmp53_ = label;
#line 110 "../games/scores/dialog.vala"
	gtk_label_set_use_markup (_tmp53_, TRUE);
#line 111 "../games/scores/dialog.vala"
	_tmp54_ = label;
#line 111 "../games/scores/dialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp54_, GTK_ALIGN_CENTER);
#line 112 "../games/scores/dialog.vala"
	_tmp55_ = catbar;
#line 112 "../games/scores/dialog.vala"
	_tmp56_ = label;
#line 112 "../games/scores/dialog.vala"
	gtk_container_add ((GtkContainer*) _tmp55_, (GtkWidget*) _tmp56_);
#line 114 "../games/scores/dialog.vala"
	_tmp57_ = games_scores_context_get_categories (context);
#line 114 "../games/scores/dialog.vala"
	categories = _tmp57_;
#line 115 "../games/scores/dialog.vala"
	if (new_high_score != NULL) {
#line 115 "../games/scores/dialog.vala"
		_tmp58_ = TRUE;
#line 607 "dialog.c"
	} else {
		GList* _tmp59_;
#line 115 "../games/scores/dialog.vala"
		_tmp59_ = categories;
#line 115 "../games/scores/dialog.vala"
		_tmp58_ = g_list_length (_tmp59_) == ((guint) 1);
#line 614 "dialog.c"
	}
#line 115 "../games/scores/dialog.vala"
	if (_tmp58_) {
#line 618 "dialog.c"
		GamesScoresCategory* _tmp64_;
		const gchar* _tmp65_;
		const gchar* _tmp66_;
		GtkLabel* _tmp67_;
		GtkLabel* _tmp68_;
		GtkLabel* _tmp69_;
		GtkLabel* _tmp70_;
		GtkBox* _tmp71_;
		GtkLabel* _tmp72_;
#line 117 "../games/scores/dialog.vala"
		if (new_high_score == NULL) {
#line 630 "dialog.c"
			GList* _tmp60_;
			GList* _tmp61_;
			gconstpointer _tmp62_;
			GamesScoresCategory* _tmp63_;
#line 118 "../games/scores/dialog.vala"
			_tmp60_ = categories;
#line 118 "../games/scores/dialog.vala"
			_tmp61_ = g_list_first (_tmp60_);
#line 118 "../games/scores/dialog.vala"
			_tmp62_ = ((GList*) _tmp61_)->data;
#line 118 "../games/scores/dialog.vala"
			_tmp63_ = _g_object_ref0 ((GamesScoresCategory*) _tmp62_);
#line 118 "../games/scores/dialog.vala"
			_g_object_unref0 (self->priv->scores_active_category);
#line 118 "../games/scores/dialog.vala"
			self->priv->scores_active_category = _tmp63_;
#line 647 "dialog.c"
		}
#line 119 "../games/scores/dialog.vala"
		_tmp64_ = self->priv->scores_active_category;
#line 119 "../games/scores/dialog.vala"
		_tmp65_ = games_scores_category_get_name (_tmp64_);
#line 119 "../games/scores/dialog.vala"
		_tmp66_ = _tmp65_;
#line 119 "../games/scores/dialog.vala"
		_tmp67_ = (GtkLabel*) gtk_label_new (_tmp66_);
#line 119 "../games/scores/dialog.vala"
		g_object_ref_sink (_tmp67_);
#line 119 "../games/scores/dialog.vala"
		_g_object_unref0 (self->priv->category_label);
#line 119 "../games/scores/dialog.vala"
		self->priv->category_label = _tmp67_;
#line 120 "../games/scores/dialog.vala"
		_tmp68_ = self->priv->category_label;
#line 120 "../games/scores/dialog.vala"
		gtk_label_set_use_markup (_tmp68_, TRUE);
#line 121 "../games/scores/dialog.vala"
		_tmp69_ = self->priv->category_label;
#line 121 "../games/scores/dialog.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp69_, GTK_ALIGN_CENTER);
#line 122 "../games/scores/dialog.vala"
		_tmp70_ = self->priv->category_label;
#line 122 "../games/scores/dialog.vala"
		gtk_widget_set_valign ((GtkWidget*) _tmp70_, GTK_ALIGN_CENTER);
#line 123 "../games/scores/dialog.vala"
		_tmp71_ = catbar;
#line 123 "../games/scores/dialog.vala"
		_tmp72_ = self->priv->category_label;
#line 123 "../games/scores/dialog.vala"
		gtk_container_add ((GtkContainer*) _tmp71_, (GtkWidget*) _tmp72_);
#line 681 "dialog.c"
	} else {
		GtkComboBoxText* _tmp73_;
		GtkComboBoxText* _tmp74_;
		GtkBox* _tmp75_;
		GtkComboBoxText* _tmp76_;
		GtkComboBoxText* _tmp77_;
#line 127 "../games/scores/dialog.vala"
		_tmp73_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
#line 127 "../games/scores/dialog.vala"
		g_object_ref_sink (_tmp73_);
#line 127 "../games/scores/dialog.vala"
		_g_object_unref0 (self->priv->combo);
#line 127 "../games/scores/dialog.vala"
		self->priv->combo = _tmp73_;
#line 128 "../games/scores/dialog.vala"
		_tmp74_ = self->priv->combo;
#line 128 "../games/scores/dialog.vala"
		gtk_widget_set_focus_on_click ((GtkWidget*) _tmp74_, FALSE);
#line 129 "../games/scores/dialog.vala"
		_tmp75_ = catbar;
#line 129 "../games/scores/dialog.vala"
		_tmp76_ = self->priv->combo;
#line 129 "../games/scores/dialog.vala"
		gtk_container_add ((GtkContainer*) _tmp75_, (GtkWidget*) _tmp76_);
#line 130 "../games/scores/dialog.vala"
		_tmp77_ = self->priv->combo;
#line 130 "../games/scores/dialog.vala"
		g_signal_connect_object ((GtkComboBox*) _tmp77_, "changed", (GCallback) _games_scores_dialog_load_scores_gtk_combo_box_changed, self, 0);
#line 710 "dialog.c"
	}
#line 133 "../games/scores/dialog.vala"
	_tmp78_ = (GtkGrid*) gtk_grid_new ();
#line 133 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp78_);
#line 133 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->grid);
#line 133 "../games/scores/dialog.vala"
	self->priv->grid = _tmp78_;
#line 134 "../games/scores/dialog.vala"
	_tmp79_ = vbox;
#line 134 "../games/scores/dialog.vala"
	_tmp80_ = self->priv->grid;
#line 134 "../games/scores/dialog.vala"
	gtk_container_add ((GtkContainer*) _tmp79_, (GtkWidget*) _tmp80_);
#line 136 "../games/scores/dialog.vala"
	_tmp81_ = self->priv->grid;
#line 136 "../games/scores/dialog.vala"
	gtk_grid_set_row_homogeneous (_tmp81_, TRUE);
#line 137 "../games/scores/dialog.vala"
	_tmp82_ = self->priv->grid;
#line 137 "../games/scores/dialog.vala"
	gtk_grid_set_column_spacing (_tmp82_, 40);
#line 138 "../games/scores/dialog.vala"
	_tmp83_ = self->priv->grid;
#line 138 "../games/scores/dialog.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp83_, 30);
#line 139 "../games/scores/dialog.vala"
	_tmp84_ = self->priv->grid;
#line 139 "../games/scores/dialog.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp84_, 30);
#line 140 "../games/scores/dialog.vala"
	_tmp85_ = self->priv->grid;
#line 140 "../games/scores/dialog.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp85_, 20);
#line 141 "../games/scores/dialog.vala"
	_tmp86_ = self->priv->grid;
#line 141 "../games/scores/dialog.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp86_, GTK_ALIGN_CENTER);
#line 144 "../games/scores/dialog.vala"
	_tmp87_ = g_strdup (_ ("Rank"));
#line 144 "../games/scores/dialog.vala"
	string_rank = _tmp87_;
#line 145 "../games/scores/dialog.vala"
	_tmp88_ = string_rank;
#line 145 "../games/scores/dialog.vala"
	_tmp89_ = g_strconcat ("<span weight='bold'>", _tmp88_, NULL);
#line 145 "../games/scores/dialog.vala"
	_tmp90_ = _tmp89_;
#line 145 "../games/scores/dialog.vala"
	_tmp91_ = g_strconcat (_tmp90_, "</span>", NULL);
#line 145 "../games/scores/dialog.vala"
	_tmp92_ = _tmp91_;
#line 145 "../games/scores/dialog.vala"
	_tmp93_ = (GtkLabel*) gtk_label_new (_tmp92_);
#line 145 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp93_);
#line 145 "../games/scores/dialog.vala"
	_tmp94_ = _tmp93_;
#line 145 "../games/scores/dialog.vala"
	_g_free0 (_tmp92_);
#line 145 "../games/scores/dialog.vala"
	_g_free0 (_tmp90_);
#line 145 "../games/scores/dialog.vala"
	label_column_1 = _tmp94_;
#line 146 "../games/scores/dialog.vala"
	_tmp95_ = label_column_1;
#line 146 "../games/scores/dialog.vala"
	gtk_label_set_use_markup (_tmp95_, TRUE);
#line 147 "../games/scores/dialog.vala"
	_tmp96_ = self->priv->grid;
#line 147 "../games/scores/dialog.vala"
	_tmp97_ = label_column_1;
#line 147 "../games/scores/dialog.vala"
	gtk_grid_attach (_tmp96_, (GtkWidget*) _tmp97_, 0, 0, 1, 1);
#line 149 "../games/scores/dialog.vala"
	_tmp98_ = g_strdup ("");
#line 149 "../games/scores/dialog.vala"
	score_or_time = _tmp98_;
#line 151 "../games/scores/dialog.vala"
	if (self->priv->scores_style == GAMES_SCORES_STYLE_POINTS_GREATER_IS_BETTER) {
#line 151 "../games/scores/dialog.vala"
		_tmp99_ = TRUE;
#line 794 "dialog.c"
	} else {
#line 151 "../games/scores/dialog.vala"
		_tmp99_ = self->priv->scores_style == GAMES_SCORES_STYLE_POINTS_LESS_IS_BETTER;
#line 798 "dialog.c"
	}
#line 151 "../games/scores/dialog.vala"
	if (_tmp99_) {
#line 802 "dialog.c"
		gchar* _tmp100_;
#line 153 "../games/scores/dialog.vala"
		_tmp100_ = g_strdup (_ ("Score"));
#line 153 "../games/scores/dialog.vala"
		_g_free0 (score_or_time);
#line 153 "../games/scores/dialog.vala"
		score_or_time = _tmp100_;
#line 810 "dialog.c"
	} else {
		gchar* _tmp101_;
#line 155 "../games/scores/dialog.vala"
		_tmp101_ = g_strdup (_ ("Time"));
#line 155 "../games/scores/dialog.vala"
		_g_free0 (score_or_time);
#line 155 "../games/scores/dialog.vala"
		score_or_time = _tmp101_;
#line 819 "dialog.c"
	}
#line 157 "../games/scores/dialog.vala"
	_tmp102_ = score_or_time;
#line 157 "../games/scores/dialog.vala"
	_tmp103_ = g_strconcat ("<span weight='bold'>", _tmp102_, NULL);
#line 157 "../games/scores/dialog.vala"
	_tmp104_ = _tmp103_;
#line 157 "../games/scores/dialog.vala"
	_tmp105_ = g_strconcat (_tmp104_, "</span>", NULL);
#line 157 "../games/scores/dialog.vala"
	_tmp106_ = _tmp105_;
#line 157 "../games/scores/dialog.vala"
	_tmp107_ = (GtkLabel*) gtk_label_new (_tmp106_);
#line 157 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp107_);
#line 157 "../games/scores/dialog.vala"
	_tmp108_ = _tmp107_;
#line 157 "../games/scores/dialog.vala"
	_g_free0 (_tmp106_);
#line 157 "../games/scores/dialog.vala"
	_g_free0 (_tmp104_);
#line 157 "../games/scores/dialog.vala"
	label_column_2 = _tmp108_;
#line 158 "../games/scores/dialog.vala"
	_tmp109_ = label_column_2;
#line 158 "../games/scores/dialog.vala"
	gtk_label_set_use_markup (_tmp109_, TRUE);
#line 159 "../games/scores/dialog.vala"
	_tmp110_ = self->priv->grid;
#line 159 "../games/scores/dialog.vala"
	_tmp111_ = label_column_2;
#line 159 "../games/scores/dialog.vala"
	gtk_grid_attach (_tmp110_, (GtkWidget*) _tmp111_, 1, 0, 1, 1);
#line 162 "../games/scores/dialog.vala"
	_tmp112_ = g_strdup (_ ("Player"));
#line 162 "../games/scores/dialog.vala"
	string_player = _tmp112_;
#line 163 "../games/scores/dialog.vala"
	_tmp113_ = string_player;
#line 163 "../games/scores/dialog.vala"
	_tmp114_ = g_strconcat ("<span weight='bold'>", _tmp113_, NULL);
#line 163 "../games/scores/dialog.vala"
	_tmp115_ = _tmp114_;
#line 163 "../games/scores/dialog.vala"
	_tmp116_ = g_strconcat (_tmp115_, "</span>", NULL);
#line 163 "../games/scores/dialog.vala"
	_tmp117_ = _tmp116_;
#line 163 "../games/scores/dialog.vala"
	_tmp118_ = (GtkLabel*) gtk_label_new (_tmp117_);
#line 163 "../games/scores/dialog.vala"
	g_object_ref_sink (_tmp118_);
#line 163 "../games/scores/dialog.vala"
	_tmp119_ = _tmp118_;
#line 163 "../games/scores/dialog.vala"
	_g_free0 (_tmp117_);
#line 163 "../games/scores/dialog.vala"
	_g_free0 (_tmp115_);
#line 163 "../games/scores/dialog.vala"
	label_column_3 = _tmp119_;
#line 164 "../games/scores/dialog.vala"
	_tmp120_ = label_column_3;
#line 164 "../games/scores/dialog.vala"
	gtk_label_set_use_markup (_tmp120_, TRUE);
#line 165 "../games/scores/dialog.vala"
	_tmp121_ = self->priv->grid;
#line 165 "../games/scores/dialog.vala"
	_tmp122_ = label_column_3;
#line 165 "../games/scores/dialog.vala"
	gtk_grid_attach (_tmp121_, (GtkWidget*) _tmp122_, 2, 0, 1, 1);
#line 167 "../games/scores/dialog.vala"
	_tmp123_ = self->priv->grid;
#line 167 "../games/scores/dialog.vala"
	gtk_grid_set_baseline_row (_tmp123_, 0);
#line 168 "../games/scores/dialog.vala"
	games_scores_dialog_fill_grid_with_labels (self);
#line 170 "../games/scores/dialog.vala"
	if (new_high_score != NULL) {
#line 897 "dialog.c"
		GtkWidget* _tmp124_;
		GtkStyleContext* _tmp125_;
#line 172 "../games/scores/dialog.vala"
		_tmp124_ = gtk_dialog_add_button ((GtkDialog*) self, _ ("_Done"), (gint) GTK_RESPONSE_OK);
#line 172 "../games/scores/dialog.vala"
		_tmp125_ = gtk_widget_get_style_context (_tmp124_);
#line 172 "../games/scores/dialog.vala"
		gtk_style_context_add_class (_tmp125_, "suggested-action");
#line 906 "dialog.c"
	}
#line 174 "../games/scores/dialog.vala"
	games_scores_dialog_load_categories (self);
#line 176 "../games/scores/dialog.vala"
	_tmp126_ = vbox;
#line 176 "../games/scores/dialog.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp126_);
#line 39 "../games/scores/dialog.vala"
	_g_object_unref0 (label_column_3);
#line 39 "../games/scores/dialog.vala"
	_g_free0 (string_player);
#line 39 "../games/scores/dialog.vala"
	_g_object_unref0 (label_column_2);
#line 39 "../games/scores/dialog.vala"
	_g_free0 (score_or_time);
#line 39 "../games/scores/dialog.vala"
	_g_object_unref0 (label_column_1);
#line 39 "../games/scores/dialog.vala"
	_g_free0 (string_rank);
#line 39 "../games/scores/dialog.vala"
	(categories == NULL) ? NULL : (categories = (_g_list_free__g_object_unref0_ (categories), NULL));
#line 39 "../games/scores/dialog.vala"
	_g_object_unref0 (label);
#line 39 "../games/scores/dialog.vala"
	_g_object_unref0 (hdiv);
#line 39 "../games/scores/dialog.vala"
	_g_object_unref0 (catbar);
#line 39 "../games/scores/dialog.vala"
	_g_object_unref0 (vbox);
#line 39 "../games/scores/dialog.vala"
	return self;
#line 938 "dialog.c"
}

GamesScoresDialog*
games_scores_dialog_new (GamesScoresContext* context,
                         const gchar* category_type,
                         GamesScoresStyle style,
                         GamesScoresScore* new_high_score,
                         GamesScoresCategory* current_cat,
                         GtkWindow* window,
                         const gchar* icon_name)
{
#line 39 "../games/scores/dialog.vala"
	return games_scores_dialog_construct (GAMES_SCORES_TYPE_DIALOG, context, category_type, style, new_high_score, current_cat, window, icon_name);
#line 952 "dialog.c"
}

static void
games_scores_dialog_fill_grid_with_labels (GamesScoresDialog* self)
{
#line 179 "../games/scores/dialog.vala"
	g_return_if_fail (self != NULL);
#line 960 "dialog.c"
	{
		gint row = 0;
#line 181 "../games/scores/dialog.vala"
		row = 1;
#line 965 "dialog.c"
		{
			gboolean _tmp0_ = FALSE;
#line 181 "../games/scores/dialog.vala"
			_tmp0_ = TRUE;
#line 181 "../games/scores/dialog.vala"
			while (TRUE) {
#line 972 "dialog.c"
				GtkStack* stack = NULL;
				GtkStack* _tmp10_;
				GtkStack* _tmp11_;
				GtkStack* _tmp12_;
				GtkStack* _tmp13_;
				GtkStack* _tmp14_;
				GtkLabel* label = NULL;
				GtkLabel* _tmp15_;
				GtkLabel* _tmp16_;
				GtkLabel* _tmp17_;
				GtkLabel* _tmp18_;
				GtkStack* _tmp19_;
				GtkLabel* _tmp20_;
				GtkEntry* entry = NULL;
				GtkEntry* _tmp21_;
				GtkEntry* _tmp22_;
				GtkEntry* _tmp23_;
				GtkEntry* _tmp24_;
				GtkEntry* _tmp25_;
				GtkStack* _tmp26_;
				GtkEntry* _tmp27_;
				GtkStack* _tmp28_;
				GtkGrid* _tmp29_;
				GtkStack* _tmp30_;
#line 181 "../games/scores/dialog.vala"
				if (!_tmp0_) {
#line 999 "dialog.c"
					gint _tmp1_;
#line 181 "../games/scores/dialog.vala"
					_tmp1_ = row;
#line 181 "../games/scores/dialog.vala"
					row = _tmp1_ + 1;
#line 1005 "dialog.c"
				}
#line 181 "../games/scores/dialog.vala"
				_tmp0_ = FALSE;
#line 181 "../games/scores/dialog.vala"
				if (!(row <= self->priv->rows_to_display)) {
#line 181 "../games/scores/dialog.vala"
					break;
#line 1013 "dialog.c"
				}
				{
					gint column = 0;
#line 183 "../games/scores/dialog.vala"
					column = 0;
#line 1019 "dialog.c"
					{
						gboolean _tmp2_ = FALSE;
#line 183 "../games/scores/dialog.vala"
						_tmp2_ = TRUE;
#line 183 "../games/scores/dialog.vala"
						while (TRUE) {
#line 1026 "dialog.c"
							GtkLabel* label = NULL;
							GtkLabel* _tmp4_;
							GtkLabel* _tmp5_;
							GtkLabel* _tmp6_;
							GtkLabel* _tmp7_;
							GtkGrid* _tmp8_;
							GtkLabel* _tmp9_;
#line 183 "../games/scores/dialog.vala"
							if (!_tmp2_) {
#line 1036 "dialog.c"
								gint _tmp3_;
#line 183 "../games/scores/dialog.vala"
								_tmp3_ = column;
#line 183 "../games/scores/dialog.vala"
								column = _tmp3_ + 1;
#line 1042 "dialog.c"
							}
#line 183 "../games/scores/dialog.vala"
							_tmp2_ = FALSE;
#line 183 "../games/scores/dialog.vala"
							if (!(column <= 1)) {
#line 183 "../games/scores/dialog.vala"
								break;
#line 1050 "dialog.c"
							}
#line 185 "../games/scores/dialog.vala"
							_tmp4_ = (GtkLabel*) gtk_label_new ("");
#line 185 "../games/scores/dialog.vala"
							g_object_ref_sink (_tmp4_);
#line 185 "../games/scores/dialog.vala"
							label = _tmp4_;
#line 186 "../games/scores/dialog.vala"
							_tmp5_ = label;
#line 186 "../games/scores/dialog.vala"
							gtk_widget_set_visible ((GtkWidget*) _tmp5_, TRUE);
#line 187 "../games/scores/dialog.vala"
							_tmp6_ = label;
#line 187 "../games/scores/dialog.vala"
							gtk_widget_set_halign ((GtkWidget*) _tmp6_, GTK_ALIGN_CENTER);
#line 188 "../games/scores/dialog.vala"
							_tmp7_ = label;
#line 188 "../games/scores/dialog.vala"
							gtk_widget_set_valign ((GtkWidget*) _tmp7_, GTK_ALIGN_CENTER);
#line 190 "../games/scores/dialog.vala"
							_tmp8_ = self->priv->grid;
#line 190 "../games/scores/dialog.vala"
							_tmp9_ = label;
#line 190 "../games/scores/dialog.vala"
							gtk_grid_attach (_tmp8_, (GtkWidget*) _tmp9_, column, row, 1, 1);
#line 183 "../games/scores/dialog.vala"
							_g_object_unref0 (label);
#line 1078 "dialog.c"
						}
					}
				}
#line 193 "../games/scores/dialog.vala"
				_tmp10_ = (GtkStack*) gtk_stack_new ();
#line 193 "../games/scores/dialog.vala"
				g_object_ref_sink (_tmp10_);
#line 193 "../games/scores/dialog.vala"
				stack = _tmp10_;
#line 194 "../games/scores/dialog.vala"
				_tmp11_ = stack;
#line 194 "../games/scores/dialog.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp11_, TRUE);
#line 195 "../games/scores/dialog.vala"
				_tmp12_ = stack;
#line 195 "../games/scores/dialog.vala"
				gtk_stack_set_homogeneous (_tmp12_, FALSE);
#line 196 "../games/scores/dialog.vala"
				_tmp13_ = stack;
#line 196 "../games/scores/dialog.vala"
				gtk_stack_set_vhomogeneous (_tmp13_, TRUE);
#line 197 "../games/scores/dialog.vala"
				_tmp14_ = stack;
#line 197 "../games/scores/dialog.vala"
				gtk_stack_set_transition_type (_tmp14_, GTK_STACK_TRANSITION_TYPE_NONE);
#line 199 "../games/scores/dialog.vala"
				_tmp15_ = (GtkLabel*) gtk_label_new ("");
#line 199 "../games/scores/dialog.vala"
				g_object_ref_sink (_tmp15_);
#line 199 "../games/scores/dialog.vala"
				label = _tmp15_;
#line 200 "../games/scores/dialog.vala"
				_tmp16_ = label;
#line 200 "../games/scores/dialog.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp16_, TRUE);
#line 201 "../games/scores/dialog.vala"
				_tmp17_ = label;
#line 201 "../games/scores/dialog.vala"
				gtk_label_set_justify (_tmp17_, GTK_JUSTIFY_CENTER);
#line 202 "../games/scores/dialog.vala"
				_tmp18_ = label;
#line 202 "../games/scores/dialog.vala"
				gtk_widget_set_valign ((GtkWidget*) _tmp18_, GTK_ALIGN_CENTER);
#line 203 "../games/scores/dialog.vala"
				_tmp19_ = stack;
#line 203 "../games/scores/dialog.vala"
				_tmp20_ = label;
#line 203 "../games/scores/dialog.vala"
				gtk_stack_add_named (_tmp19_, (GtkWidget*) _tmp20_, "label");
#line 205 "../games/scores/dialog.vala"
				_tmp21_ = (GtkEntry*) gtk_entry_new ();
#line 205 "../games/scores/dialog.vala"
				g_object_ref_sink (_tmp21_);
#line 205 "../games/scores/dialog.vala"
				entry = _tmp21_;
#line 206 "../games/scores/dialog.vala"
				_tmp22_ = entry;
#line 206 "../games/scores/dialog.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp22_, TRUE);
#line 207 "../games/scores/dialog.vala"
				_tmp23_ = entry;
#line 207 "../games/scores/dialog.vala"
				gtk_widget_set_size_request ((GtkWidget*) _tmp23_, 20, 20);
#line 208 "../games/scores/dialog.vala"
				_tmp24_ = entry;
#line 208 "../games/scores/dialog.vala"
				gtk_widget_set_hexpand ((GtkWidget*) _tmp24_, FALSE);
#line 209 "../games/scores/dialog.vala"
				_tmp25_ = entry;
#line 209 "../games/scores/dialog.vala"
				gtk_widget_set_vexpand ((GtkWidget*) _tmp25_, FALSE);
#line 210 "../games/scores/dialog.vala"
				_tmp26_ = stack;
#line 210 "../games/scores/dialog.vala"
				_tmp27_ = entry;
#line 210 "../games/scores/dialog.vala"
				gtk_stack_add_named (_tmp26_, (GtkWidget*) _tmp27_, "entry");
#line 212 "../games/scores/dialog.vala"
				_tmp28_ = stack;
#line 212 "../games/scores/dialog.vala"
				gtk_stack_set_visible_child_name (_tmp28_, "label");
#line 213 "../games/scores/dialog.vala"
				_tmp29_ = self->priv->grid;
#line 213 "../games/scores/dialog.vala"
				_tmp30_ = stack;
#line 213 "../games/scores/dialog.vala"
				gtk_grid_attach (_tmp29_, (GtkWidget*) _tmp30_, 2, row, 1, 1);
#line 181 "../games/scores/dialog.vala"
				_g_object_unref0 (entry);
#line 181 "../games/scores/dialog.vala"
				_g_object_unref0 (label);
#line 181 "../games/scores/dialog.vala"
				_g_object_unref0 (stack);
#line 1172 "dialog.c"
			}
		}
	}
}

static void
__lambda10_ (GamesScoresDialog* self,
             GamesScoresCategory* x)
{
	GtkComboBoxText* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
#line 230 "../games/scores/dialog.vala"
	_tmp0_ = self->priv->combo;
#line 230 "../games/scores/dialog.vala"
	_tmp1_ = games_scores_category_get_key (x);
#line 230 "../games/scores/dialog.vala"
	_tmp2_ = _tmp1_;
#line 230 "../games/scores/dialog.vala"
	_tmp3_ = games_scores_category_get_name (x);
#line 230 "../games/scores/dialog.vala"
	_tmp4_ = _tmp3_;
#line 230 "../games/scores/dialog.vala"
	gtk_combo_box_text_append (_tmp0_, _tmp2_, _tmp4_);
#line 1199 "dialog.c"
}

static void
___lambda10__gfunc (gconstpointer data,
                    gpointer self)
{
#line 230 "../games/scores/dialog.vala"
	__lambda10_ ((GamesScoresDialog*) self, (GamesScoresCategory*) data);
#line 1208 "dialog.c"
}

static void
games_scores_dialog_load_categories (GamesScoresDialog* self)
{
	gboolean _tmp0_ = FALSE;
	GamesScoresScore* _tmp1_;
	GtkComboBoxText* _tmp3_;
	GList* categories = NULL;
	GamesScoresContext* _tmp4_;
	GList* _tmp5_;
	GList* _tmp6_;
	GamesScoresCategory* _tmp7_;
	GamesScoresCategory* _tmp17_;
#line 218 "../games/scores/dialog.vala"
	g_return_if_fail (self != NULL);
#line 221 "../games/scores/dialog.vala"
	_tmp1_ = self->priv->new_high_score;
#line 221 "../games/scores/dialog.vala"
	if (_tmp1_ != NULL) {
#line 221 "../games/scores/dialog.vala"
		_tmp0_ = TRUE;
#line 1231 "dialog.c"
	} else {
		GtkComboBoxText* _tmp2_;
#line 221 "../games/scores/dialog.vala"
		_tmp2_ = self->priv->combo;
#line 221 "../games/scores/dialog.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 1238 "dialog.c"
	}
#line 221 "../games/scores/dialog.vala"
	if (_tmp0_) {
#line 223 "../games/scores/dialog.vala"
		games_scores_dialog_load_scores (self);
#line 1244 "dialog.c"
	}
#line 226 "../games/scores/dialog.vala"
	_tmp3_ = self->priv->combo;
#line 226 "../games/scores/dialog.vala"
	if (_tmp3_ == NULL) {
#line 227 "../games/scores/dialog.vala"
		return;
#line 1252 "dialog.c"
	}
#line 229 "../games/scores/dialog.vala"
	_tmp4_ = self->priv->context;
#line 229 "../games/scores/dialog.vala"
	_tmp5_ = games_scores_context_get_categories (_tmp4_);
#line 229 "../games/scores/dialog.vala"
	categories = _tmp5_;
#line 230 "../games/scores/dialog.vala"
	_tmp6_ = categories;
#line 230 "../games/scores/dialog.vala"
	g_list_foreach (_tmp6_, ___lambda10__gfunc, self);
#line 232 "../games/scores/dialog.vala"
	_tmp7_ = self->priv->scores_active_category;
#line 232 "../games/scores/dialog.vala"
	if (_tmp7_ == NULL) {
#line 1268 "dialog.c"
		GtkComboBoxText* _tmp8_;
		GList* _tmp9_;
		gconstpointer _tmp10_;
		const gchar* _tmp11_;
		const gchar* _tmp12_;
#line 233 "../games/scores/dialog.vala"
		_tmp8_ = self->priv->combo;
#line 233 "../games/scores/dialog.vala"
		_tmp9_ = categories;
#line 233 "../games/scores/dialog.vala"
		_tmp10_ = g_list_nth_data (_tmp9_, (guint) 0);
#line 233 "../games/scores/dialog.vala"
		_tmp11_ = games_scores_category_get_key ((GamesScoresCategory*) _tmp10_);
#line 233 "../games/scores/dialog.vala"
		_tmp12_ = _tmp11_;
#line 233 "../games/scores/dialog.vala"
		gtk_combo_box_set_active_id ((GtkComboBox*) _tmp8_, _tmp12_);
#line 1286 "dialog.c"
	} else {
		GtkComboBoxText* _tmp13_;
		GamesScoresCategory* _tmp14_;
		const gchar* _tmp15_;
		const gchar* _tmp16_;
#line 235 "../games/scores/dialog.vala"
		_tmp13_ = self->priv->combo;
#line 235 "../games/scores/dialog.vala"
		_tmp14_ = self->priv->scores_active_category;
#line 235 "../games/scores/dialog.vala"
		_tmp15_ = games_scores_category_get_key (_tmp14_);
#line 235 "../games/scores/dialog.vala"
		_tmp16_ = _tmp15_;
#line 235 "../games/scores/dialog.vala"
		gtk_combo_box_set_active_id ((GtkComboBox*) _tmp13_, _tmp16_);
#line 1302 "dialog.c"
	}
#line 237 "../games/scores/dialog.vala"
	_tmp17_ = self->priv->active_category;
#line 237 "../games/scores/dialog.vala"
	if (_tmp17_ == NULL) {
#line 1308 "dialog.c"
		GList* _tmp18_;
		gconstpointer _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		GList* _tmp22_;
		gconstpointer _tmp23_;
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		GamesScoresCategory* _tmp26_;
#line 239 "../games/scores/dialog.vala"
		_tmp18_ = categories;
#line 239 "../games/scores/dialog.vala"
		_tmp19_ = g_list_nth_data (_tmp18_, (guint) 0);
#line 239 "../games/scores/dialog.vala"
		_tmp20_ = games_scores_category_get_key ((GamesScoresCategory*) _tmp19_);
#line 239 "../games/scores/dialog.vala"
		_tmp21_ = _tmp20_;
#line 239 "../games/scores/dialog.vala"
		_tmp22_ = categories;
#line 239 "../games/scores/dialog.vala"
		_tmp23_ = g_list_nth_data (_tmp22_, (guint) 0);
#line 239 "../games/scores/dialog.vala"
		_tmp24_ = games_scores_category_get_name ((GamesScoresCategory*) _tmp23_);
#line 239 "../games/scores/dialog.vala"
		_tmp25_ = _tmp24_;
#line 239 "../games/scores/dialog.vala"
		_tmp26_ = games_scores_category_new (_tmp21_, _tmp25_);
#line 239 "../games/scores/dialog.vala"
		_g_object_unref0 (self->priv->active_category);
#line 239 "../games/scores/dialog.vala"
		self->priv->active_category = _tmp26_;
#line 1340 "dialog.c"
	} else {
		GamesScoresCategory* _tmp27_;
		GList* _tmp28_;
		gconstpointer _tmp29_;
		const gchar* _tmp30_;
		const gchar* _tmp31_;
		GamesScoresCategory* _tmp32_;
		GList* _tmp33_;
		gconstpointer _tmp34_;
		const gchar* _tmp35_;
		const gchar* _tmp36_;
#line 243 "../games/scores/dialog.vala"
		_tmp27_ = self->priv->active_category;
#line 243 "../games/scores/dialog.vala"
		_tmp28_ = categories;
#line 243 "../games/scores/dialog.vala"
		_tmp29_ = g_list_nth_data (_tmp28_, (guint) 0);
#line 243 "../games/scores/dialog.vala"
		_tmp30_ = games_scores_category_get_key ((GamesScoresCategory*) _tmp29_);
#line 243 "../games/scores/dialog.vala"
		_tmp31_ = _tmp30_;
#line 243 "../games/scores/dialog.vala"
		games_scores_category_set_key (_tmp27_, _tmp31_);
#line 244 "../games/scores/dialog.vala"
		_tmp32_ = self->priv->active_category;
#line 244 "../games/scores/dialog.vala"
		_tmp33_ = categories;
#line 244 "../games/scores/dialog.vala"
		_tmp34_ = g_list_nth_data (_tmp33_, (guint) 0);
#line 244 "../games/scores/dialog.vala"
		_tmp35_ = games_scores_category_get_name ((GamesScoresCategory*) _tmp34_);
#line 244 "../games/scores/dialog.vala"
		_tmp36_ = _tmp35_;
#line 244 "../games/scores/dialog.vala"
		games_scores_category_set_name (_tmp32_, _tmp36_);
#line 1376 "dialog.c"
	}
#line 218 "../games/scores/dialog.vala"
	(categories == NULL) ? NULL : (categories = (_g_list_free__g_object_unref0_ (categories), NULL));
#line 1380 "dialog.c"
}

static void
games_scores_dialog_load_scores (GamesScoresDialog* self)
{
	gboolean _tmp0_ = FALSE;
	GamesScoresScore* _tmp1_;
	GeeList* best_n_scores = NULL;
	GamesScoresContext* _tmp16_;
	GamesScoresCategory* _tmp17_;
	GeeList* _tmp18_;
	gint row_count = 0;
#line 249 "../games/scores/dialog.vala"
	g_return_if_fail (self != NULL);
#line 251 "../games/scores/dialog.vala"
	_tmp1_ = self->priv->new_high_score;
#line 251 "../games/scores/dialog.vala"
	if (_tmp1_ != NULL) {
#line 251 "../games/scores/dialog.vala"
		_tmp0_ = TRUE;
#line 1401 "dialog.c"
	} else {
		GtkComboBoxText* _tmp2_;
#line 251 "../games/scores/dialog.vala"
		_tmp2_ = self->priv->combo;
#line 251 "../games/scores/dialog.vala"
		_tmp0_ = _tmp2_ == NULL;
#line 1408 "dialog.c"
	}
#line 251 "../games/scores/dialog.vala"
	if (_tmp0_) {
#line 1412 "dialog.c"
		GamesScoresCategory* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		GamesScoresCategory* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		GamesScoresCategory* _tmp9_;
#line 252 "../games/scores/dialog.vala"
		_tmp3_ = self->priv->scores_active_category;
#line 252 "../games/scores/dialog.vala"
		_tmp4_ = games_scores_category_get_key (_tmp3_);
#line 252 "../games/scores/dialog.vala"
		_tmp5_ = _tmp4_;
#line 252 "../games/scores/dialog.vala"
		_tmp6_ = self->priv->scores_active_category;
#line 252 "../games/scores/dialog.vala"
		_tmp7_ = games_scores_category_get_name (_tmp6_);
#line 252 "../games/scores/dialog.vala"
		_tmp8_ = _tmp7_;
#line 252 "../games/scores/dialog.vala"
		_tmp9_ = games_scores_category_new (_tmp5_, _tmp8_);
#line 252 "../games/scores/dialog.vala"
		_g_object_unref0 (self->priv->active_category);
#line 252 "../games/scores/dialog.vala"
		self->priv->active_category = _tmp9_;
#line 1438 "dialog.c"
	} else {
		GtkComboBoxText* _tmp10_;
		const gchar* _tmp11_;
		GtkComboBoxText* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GamesScoresCategory* _tmp15_;
#line 254 "../games/scores/dialog.vala"
		_tmp10_ = self->priv->combo;
#line 254 "../games/scores/dialog.vala"
		_tmp11_ = gtk_combo_box_get_active_id ((GtkComboBox*) _tmp10_);
#line 254 "../games/scores/dialog.vala"
		_tmp12_ = self->priv->combo;
#line 254 "../games/scores/dialog.vala"
		_tmp13_ = gtk_combo_box_text_get_active_text (_tmp12_);
#line 254 "../games/scores/dialog.vala"
		_tmp14_ = _tmp13_;
#line 254 "../games/scores/dialog.vala"
		_tmp15_ = games_scores_category_new (_tmp11_, _tmp14_);
#line 254 "../games/scores/dialog.vala"
		_g_object_unref0 (self->priv->active_category);
#line 254 "../games/scores/dialog.vala"
		self->priv->active_category = _tmp15_;
#line 254 "../games/scores/dialog.vala"
		_g_free0 (_tmp14_);
#line 1464 "dialog.c"
	}
#line 256 "../games/scores/dialog.vala"
	_tmp16_ = self->priv->context;
#line 256 "../games/scores/dialog.vala"
	_tmp17_ = self->priv->active_category;
#line 256 "../games/scores/dialog.vala"
	_tmp18_ = games_scores_context_get_high_scores (_tmp16_, _tmp17_, self->priv->rows_to_display);
#line 256 "../games/scores/dialog.vala"
	best_n_scores = _tmp18_;
#line 258 "../games/scores/dialog.vala"
	row_count = 1;
#line 1476 "dialog.c"
	{
		GeeList* _score_list = NULL;
		GeeList* _tmp19_;
		gint _score_size = 0;
		GeeList* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		gint _score_index = 0;
#line 260 "../games/scores/dialog.vala"
		_tmp19_ = best_n_scores;
#line 260 "../games/scores/dialog.vala"
		_score_list = _tmp19_;
#line 260 "../games/scores/dialog.vala"
		_tmp20_ = _score_list;
#line 260 "../games/scores/dialog.vala"
		_tmp21_ = gee_collection_get_size ((GeeCollection*) _tmp20_);
#line 260 "../games/scores/dialog.vala"
		_tmp22_ = _tmp21_;
#line 260 "../games/scores/dialog.vala"
		_score_size = _tmp22_;
#line 260 "../games/scores/dialog.vala"
		_score_index = -1;
#line 260 "../games/scores/dialog.vala"
		while (TRUE) {
#line 1501 "dialog.c"
			gint _tmp23_;
			gint _tmp24_;
			GamesScoresScore* score = NULL;
			GeeList* _tmp25_;
			gpointer _tmp26_;
			GamesScoresScore* _tmp27_;
			GeeList* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gint _tmp31_;
#line 260 "../games/scores/dialog.vala"
			_score_index = _score_index + 1;
#line 260 "../games/scores/dialog.vala"
			_tmp23_ = _score_index;
#line 260 "../games/scores/dialog.vala"
			_tmp24_ = _score_size;
#line 260 "../games/scores/dialog.vala"
			if (!(_tmp23_ < _tmp24_)) {
#line 260 "../games/scores/dialog.vala"
				break;
#line 1522 "dialog.c"
			}
#line 260 "../games/scores/dialog.vala"
			_tmp25_ = _score_list;
#line 260 "../games/scores/dialog.vala"
			_tmp26_ = gee_list_get (_tmp25_, _score_index);
#line 260 "../games/scores/dialog.vala"
			score = (GamesScoresScore*) _tmp26_;
#line 262 "../games/scores/dialog.vala"
			_tmp27_ = score;
#line 262 "../games/scores/dialog.vala"
			_tmp28_ = best_n_scores;
#line 262 "../games/scores/dialog.vala"
			_tmp29_ = gee_collection_get_size ((GeeCollection*) _tmp28_);
#line 262 "../games/scores/dialog.vala"
			_tmp30_ = _tmp29_;
#line 262 "../games/scores/dialog.vala"
			games_scores_dialog_display_single_score (self, _tmp27_, row_count, (guint) _tmp30_);
#line 263 "../games/scores/dialog.vala"
			_tmp31_ = row_count;
#line 263 "../games/scores/dialog.vala"
			row_count = _tmp31_ + 1;
#line 260 "../games/scores/dialog.vala"
			_g_object_unref0 (score);
#line 1546 "dialog.c"
		}
	}
#line 266 "../games/scores/dialog.vala"
	if (row_count < (self->priv->rows_to_display + 1)) {
#line 267 "../games/scores/dialog.vala"
		games_scores_dialog_make_remaining_labels_empty (self, row_count);
#line 1553 "dialog.c"
	}
#line 249 "../games/scores/dialog.vala"
	_g_object_unref0 (best_n_scores);
#line 1557 "dialog.c"
}

static Block4Data*
block4_data_ref (Block4Data* _data4_)
{
#line 272 "../games/scores/dialog.vala"
	g_atomic_int_inc (&_data4_->_ref_count_);
#line 272 "../games/scores/dialog.vala"
	return _data4_;
#line 1567 "dialog.c"
}

static void
block4_data_unref (void * _userdata_)
{
	Block4Data* _data4_;
	_data4_ = (Block4Data*) _userdata_;
#line 272 "../games/scores/dialog.vala"
	if (g_atomic_int_dec_and_test (&_data4_->_ref_count_)) {
#line 1577 "dialog.c"
		GamesScoresDialog* self;
#line 272 "../games/scores/dialog.vala"
		self = _data4_->self;
#line 272 "../games/scores/dialog.vala"
		_g_object_unref0 (_data4_->score);
#line 272 "../games/scores/dialog.vala"
		_g_object_unref0 (self);
#line 272 "../games/scores/dialog.vala"
		g_slice_free (Block4Data, _data4_);
#line 1587 "dialog.c"
	}
}

static Block5Data*
block5_data_ref (Block5Data* _data5_)
{
#line 293 "../games/scores/dialog.vala"
	g_atomic_int_inc (&_data5_->_ref_count_);
#line 293 "../games/scores/dialog.vala"
	return _data5_;
#line 1598 "dialog.c"
}

static void
block5_data_unref (void * _userdata_)
{
	Block5Data* _data5_;
	_data5_ = (Block5Data*) _userdata_;
#line 293 "../games/scores/dialog.vala"
	if (g_atomic_int_dec_and_test (&_data5_->_ref_count_)) {
#line 1608 "dialog.c"
		GamesScoresDialog* self;
#line 293 "../games/scores/dialog.vala"
		self = _data5_->_data4_->self;
#line 293 "../games/scores/dialog.vala"
		_g_object_unref0 (_data5_->entry);
#line 293 "../games/scores/dialog.vala"
		block4_data_unref (_data5_->_data4_);
#line 293 "../games/scores/dialog.vala"
		_data5_->_data4_ = NULL;
#line 293 "../games/scores/dialog.vala"
		g_slice_free (Block5Data, _data5_);
#line 1620 "dialog.c"
	}
}

static void
___lambda9_ (Block5Data* _data5_)
{
	Block4Data* _data4_;
	GamesScoresDialog* self;
	GamesScoresContext* _tmp0_;
	GamesScoresCategory* _tmp1_;
	GtkEntry* _tmp2_;
	const gchar* _tmp3_;
	GtkEntry* _tmp4_;
	const gchar* _tmp5_;
#line 305 "../games/scores/dialog.vala"
	_data4_ = _data5_->_data4_;
#line 305 "../games/scores/dialog.vala"
	self = _data4_->self;
#line 306 "../games/scores/dialog.vala"
	_tmp0_ = self->priv->context;
#line 306 "../games/scores/dialog.vala"
	_tmp1_ = self->priv->active_category;
#line 306 "../games/scores/dialog.vala"
	_tmp2_ = _data5_->entry;
#line 306 "../games/scores/dialog.vala"
	_tmp3_ = gtk_entry_get_text (_tmp2_);
#line 306 "../games/scores/dialog.vala"
	games_scores_context_update_score_name (_tmp0_, _data4_->score, _tmp1_, _tmp3_);
#line 307 "../games/scores/dialog.vala"
	_tmp4_ = _data5_->entry;
#line 307 "../games/scores/dialog.vala"
	_tmp5_ = gtk_entry_get_text (_tmp4_);
#line 307 "../games/scores/dialog.vala"
	games_scores_score_set_user (_data4_->score, _tmp5_);
#line 1655 "dialog.c"
}

static void
____lambda9__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 305 "../games/scores/dialog.vala"
	___lambda9_ (self);
#line 1665 "dialog.c"
}

static void
games_scores_dialog_display_single_score (GamesScoresDialog* self,
                                          GamesScoresScore* score,
                                          gint row_count,
                                          guint no_scores)
{
	Block4Data* _data4_;
	GamesScoresScore* _tmp0_;
	GtkLabel* rank_label = NULL;
	GtkGrid* _tmp1_;
	GtkWidget* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	GtkLabel* score_label = NULL;
	GtkGrid* _tmp7_;
	GtkWidget* _tmp8_;
	GtkLabel* _tmp9_;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp27_ = FALSE;
	GamesScoresScore* _tmp28_;
	GtkStack* name_stack = NULL;
	GtkGrid* _tmp44_;
	GtkWidget* _tmp45_;
	GtkStack* _tmp46_;
	GtkWidget* widget = NULL;
	GtkStack* _tmp47_;
	GtkWidget* _tmp48_;
	GtkWidget* _tmp49_;
	GtkStack* _tmp50_;
	const gchar* _tmp51_;
#line 272 "../games/scores/dialog.vala"
	g_return_if_fail (self != NULL);
#line 272 "../games/scores/dialog.vala"
	g_return_if_fail (score != NULL);
#line 272 "../games/scores/dialog.vala"
	_data4_ = g_slice_new0 (Block4Data);
#line 272 "../games/scores/dialog.vala"
	_data4_->_ref_count_ = 1;
#line 272 "../games/scores/dialog.vala"
	_data4_->self = g_object_ref (self);
#line 272 "../games/scores/dialog.vala"
	_tmp0_ = _g_object_ref0 (score);
#line 272 "../games/scores/dialog.vala"
	_g_object_unref0 (_data4_->score);
#line 272 "../games/scores/dialog.vala"
	_data4_->score = _tmp0_;
#line 274 "../games/scores/dialog.vala"
	_tmp1_ = self->priv->grid;
#line 274 "../games/scores/dialog.vala"
	_tmp2_ = gtk_grid_get_child_at (_tmp1_, 0, row_count);
#line 274 "../games/scores/dialog.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, gtk_label_get_type (), GtkLabel));
#line 274 "../games/scores/dialog.vala"
	rank_label = _tmp3_;
#line 275 "../games/scores/dialog.vala"
	_tmp4_ = rank_label;
#line 275 "../games/scores/dialog.vala"
	_tmp5_ = g_strdup_printf ("%i", row_count);
#line 275 "../games/scores/dialog.vala"
	_tmp6_ = _tmp5_;
#line 275 "../games/scores/dialog.vala"
	gtk_label_set_text (_tmp4_, _tmp6_);
#line 275 "../games/scores/dialog.vala"
	_g_free0 (_tmp6_);
#line 277 "../games/scores/dialog.vala"
	_tmp7_ = self->priv->grid;
#line 277 "../games/scores/dialog.vala"
	_tmp8_ = gtk_grid_get_child_at (_tmp7_, 1, row_count);
#line 277 "../games/scores/dialog.vala"
	_tmp9_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp8_, gtk_label_get_type (), GtkLabel));
#line 277 "../games/scores/dialog.vala"
	score_label = _tmp9_;
#line 278 "../games/scores/dialog.vala"
	if (self->priv->scores_style == GAMES_SCORES_STYLE_POINTS_GREATER_IS_BETTER) {
#line 278 "../games/scores/dialog.vala"
		_tmp10_ = TRUE;
#line 1746 "dialog.c"
	} else {
#line 278 "../games/scores/dialog.vala"
		_tmp10_ = self->priv->scores_style == GAMES_SCORES_STYLE_POINTS_LESS_IS_BETTER;
#line 1750 "dialog.c"
	}
#line 278 "../games/scores/dialog.vala"
	if (_tmp10_) {
#line 1754 "dialog.c"
		GtkLabel* _tmp11_;
		glong _tmp12_;
		glong _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
#line 280 "../games/scores/dialog.vala"
		_tmp11_ = score_label;
#line 280 "../games/scores/dialog.vala"
		_tmp12_ = games_scores_score_get_score (_data4_->score);
#line 280 "../games/scores/dialog.vala"
		_tmp13_ = _tmp12_;
#line 280 "../games/scores/dialog.vala"
		_tmp14_ = g_strdup_printf ("%li", _tmp13_);
#line 280 "../games/scores/dialog.vala"
		_tmp15_ = _tmp14_;
#line 280 "../games/scores/dialog.vala"
		gtk_label_set_text (_tmp11_, _tmp15_);
#line 280 "../games/scores/dialog.vala"
		_g_free0 (_tmp15_);
#line 1774 "dialog.c"
	} else {
		glong minutes = 0L;
		glong _tmp16_;
		glong _tmp17_;
		glong seconds = 0L;
		glong _tmp18_;
		glong _tmp19_;
		GtkLabel* _tmp20_;
		gchar* _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
#line 284 "../games/scores/dialog.vala"
		_tmp16_ = games_scores_score_get_score (_data4_->score);
#line 284 "../games/scores/dialog.vala"
		_tmp17_ = _tmp16_;
#line 284 "../games/scores/dialog.vala"
		minutes = _tmp17_ / 60;
#line 285 "../games/scores/dialog.vala"
		_tmp18_ = games_scores_score_get_score (_data4_->score);
#line 285 "../games/scores/dialog.vala"
		_tmp19_ = _tmp18_;
#line 285 "../games/scores/dialog.vala"
		seconds = _tmp19_ % 60;
#line 286 "../games/scores/dialog.vala"
		_tmp20_ = score_label;
#line 286 "../games/scores/dialog.vala"
		_tmp21_ = g_strdup_printf (ngettext ("%ld minute", "%ld minutes", (gulong) minutes), minutes);
#line 286 "../games/scores/dialog.vala"
		_tmp22_ = _tmp21_;
#line 286 "../games/scores/dialog.vala"
		_tmp23_ = g_strdup_printf (ngettext ("%ld second", "%ld seconds", (gulong) seconds), seconds);
#line 286 "../games/scores/dialog.vala"
		_tmp24_ = _tmp23_;
#line 286 "../games/scores/dialog.vala"
		_tmp25_ = g_strdup_printf ("%s %s", _tmp22_, _tmp24_);
#line 286 "../games/scores/dialog.vala"
		_tmp26_ = _tmp25_;
#line 286 "../games/scores/dialog.vala"
		gtk_label_set_text (_tmp20_, _tmp26_);
#line 286 "../games/scores/dialog.vala"
		_g_free0 (_tmp26_);
#line 286 "../games/scores/dialog.vala"
		_g_free0 (_tmp24_);
#line 286 "../games/scores/dialog.vala"
		_g_free0 (_tmp22_);
#line 1823 "dialog.c"
	}
#line 293 "../games/scores/dialog.vala"
	_tmp28_ = self->priv->new_high_score;
#line 293 "../games/scores/dialog.vala"
	if (_tmp28_ != NULL) {
#line 1829 "dialog.c"
		GamesScoresScore* _tmp29_;
#line 293 "../games/scores/dialog.vala"
		_tmp29_ = self->priv->new_high_score;
#line 293 "../games/scores/dialog.vala"
		_tmp27_ = games_scores_score_equals (_data4_->score, _tmp29_);
#line 1835 "dialog.c"
	} else {
#line 293 "../games/scores/dialog.vala"
		_tmp27_ = FALSE;
#line 1839 "dialog.c"
	}
#line 293 "../games/scores/dialog.vala"
	if (_tmp27_) {
#line 1843 "dialog.c"
		Block5Data* _data5_;
		gboolean _tmp30_ = FALSE;
		GtkStack* temp_stack = NULL;
		GtkGrid* _tmp33_;
		GtkWidget* _tmp34_;
		GtkStack* _tmp35_;
		GtkStack* _tmp36_;
		GtkStack* _tmp37_;
		GtkWidget* _tmp38_;
		GtkEntry* _tmp39_;
		GtkEntry* _tmp40_;
		const gchar* _tmp41_;
		const gchar* _tmp42_;
		GtkEntry* _tmp43_;
#line 293 "../games/scores/dialog.vala"
		_data5_ = g_slice_new0 (Block5Data);
#line 293 "../games/scores/dialog.vala"
		_data5_->_ref_count_ = 1;
#line 293 "../games/scores/dialog.vala"
		_data5_->_data4_ = block4_data_ref (_data4_);
#line 295 "../games/scores/dialog.vala"
		if (no_scores > ((guint) 1)) {
#line 295 "../games/scores/dialog.vala"
			_tmp30_ = row_count == 1;
#line 1868 "dialog.c"
		} else {
#line 295 "../games/scores/dialog.vala"
			_tmp30_ = FALSE;
#line 1872 "dialog.c"
		}
#line 295 "../games/scores/dialog.vala"
		if (_tmp30_) {
#line 1876 "dialog.c"
			GtkHeaderBar* _tmp31_;
#line 296 "../games/scores/dialog.vala"
			_tmp31_ = self->priv->headerbar;
#line 296 "../games/scores/dialog.vala"
			gtk_header_bar_set_subtitle (_tmp31_, _ ("Your score is the best!"));
#line 1882 "dialog.c"
		} else {
			GtkHeaderBar* _tmp32_;
#line 298 "../games/scores/dialog.vala"
			_tmp32_ = self->priv->headerbar;
#line 298 "../games/scores/dialog.vala"
			gtk_header_bar_set_subtitle (_tmp32_, _ ("Your score has made the top ten."));
#line 1889 "dialog.c"
		}
#line 300 "../games/scores/dialog.vala"
		_tmp33_ = self->priv->grid;
#line 300 "../games/scores/dialog.vala"
		_tmp34_ = gtk_grid_get_child_at (_tmp33_, 2, row_count);
#line 300 "../games/scores/dialog.vala"
		_tmp35_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp34_, gtk_stack_get_type (), GtkStack));
#line 300 "../games/scores/dialog.vala"
		temp_stack = _tmp35_;
#line 301 "../games/scores/dialog.vala"
		_tmp36_ = temp_stack;
#line 301 "../games/scores/dialog.vala"
		gtk_stack_set_visible_child_name (_tmp36_, "entry");
#line 303 "../games/scores/dialog.vala"
		_tmp37_ = temp_stack;
#line 303 "../games/scores/dialog.vala"
		_tmp38_ = gtk_stack_get_visible_child (_tmp37_);
#line 303 "../games/scores/dialog.vala"
		_tmp39_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp38_, gtk_entry_get_type (), GtkEntry));
#line 303 "../games/scores/dialog.vala"
		_data5_->entry = _tmp39_;
#line 304 "../games/scores/dialog.vala"
		_tmp40_ = _data5_->entry;
#line 304 "../games/scores/dialog.vala"
		_tmp41_ = games_scores_score_get_user (_data4_->score);
#line 304 "../games/scores/dialog.vala"
		_tmp42_ = _tmp41_;
#line 304 "../games/scores/dialog.vala"
		gtk_entry_set_text (_tmp40_, _tmp42_);
#line 305 "../games/scores/dialog.vala"
		_tmp43_ = _data5_->entry;
#line 305 "../games/scores/dialog.vala"
		g_signal_connect_data ((GObject*) _tmp43_, "notify::text", (GCallback) ____lambda9__g_object_notify, block5_data_ref (_data5_), (GClosureNotify) block5_data_unref, 0);
#line 293 "../games/scores/dialog.vala"
		_g_object_unref0 (temp_stack);
#line 293 "../games/scores/dialog.vala"
		block5_data_unref (_data5_);
#line 293 "../games/scores/dialog.vala"
		_data5_ = NULL;
#line 1929 "dialog.c"
	}
#line 311 "../games/scores/dialog.vala"
	_tmp44_ = self->priv->grid;
#line 311 "../games/scores/dialog.vala"
	_tmp45_ = gtk_grid_get_child_at (_tmp44_, 2, row_count);
#line 311 "../games/scores/dialog.vala"
	_tmp46_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, gtk_stack_get_type (), GtkStack));
#line 311 "../games/scores/dialog.vala"
	name_stack = _tmp46_;
#line 312 "../games/scores/dialog.vala"
	_tmp47_ = name_stack;
#line 312 "../games/scores/dialog.vala"
	_tmp48_ = gtk_stack_get_visible_child (_tmp47_);
#line 312 "../games/scores/dialog.vala"
	_tmp49_ = _g_object_ref0 (_tmp48_);
#line 312 "../games/scores/dialog.vala"
	widget = _tmp49_;
#line 314 "../games/scores/dialog.vala"
	_tmp50_ = name_stack;
#line 314 "../games/scores/dialog.vala"
	_tmp51_ = gtk_stack_get_visible_child_name (_tmp50_);
#line 314 "../games/scores/dialog.vala"
	if (g_strcmp0 (_tmp51_, "label") == 0) {
#line 1953 "dialog.c"
		GtkLabel* user_label = NULL;
		GtkWidget* _tmp52_;
		GtkLabel* _tmp53_;
		GtkLabel* _tmp54_;
		const gchar* _tmp55_;
		const gchar* _tmp56_;
#line 316 "../games/scores/dialog.vala"
		_tmp52_ = widget;
#line 316 "../games/scores/dialog.vala"
		_tmp53_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, gtk_label_get_type (), GtkLabel));
#line 316 "../games/scores/dialog.vala"
		user_label = _tmp53_;
#line 317 "../games/scores/dialog.vala"
		_tmp54_ = user_label;
#line 317 "../games/scores/dialog.vala"
		_tmp55_ = games_scores_score_get_user (_data4_->score);
#line 317 "../games/scores/dialog.vala"
		_tmp56_ = _tmp55_;
#line 317 "../games/scores/dialog.vala"
		gtk_label_set_text (_tmp54_, _tmp56_);
#line 314 "../games/scores/dialog.vala"
		_g_object_unref0 (user_label);
#line 1976 "dialog.c"
	} else {
		GtkEntry* entry = NULL;
		GtkWidget* _tmp57_;
		GtkEntry* _tmp58_;
		GtkEntry* _tmp59_;
		const gchar* _tmp60_;
		const gchar* _tmp61_;
#line 321 "../games/scores/dialog.vala"
		_tmp57_ = widget;
#line 321 "../games/scores/dialog.vala"
		_tmp58_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp57_, gtk_entry_get_type (), GtkEntry));
#line 321 "../games/scores/dialog.vala"
		entry = _tmp58_;
#line 322 "../games/scores/dialog.vala"
		_tmp59_ = entry;
#line 322 "../games/scores/dialog.vala"
		_tmp60_ = games_scores_score_get_user (_data4_->score);
#line 322 "../games/scores/dialog.vala"
		_tmp61_ = _tmp60_;
#line 322 "../games/scores/dialog.vala"
		gtk_entry_set_text (_tmp59_, _tmp61_);
#line 314 "../games/scores/dialog.vala"
		_g_object_unref0 (entry);
#line 2000 "dialog.c"
	}
#line 272 "../games/scores/dialog.vala"
	_g_object_unref0 (widget);
#line 272 "../games/scores/dialog.vala"
	_g_object_unref0 (name_stack);
#line 272 "../games/scores/dialog.vala"
	_g_object_unref0 (score_label);
#line 272 "../games/scores/dialog.vala"
	_g_object_unref0 (rank_label);
#line 272 "../games/scores/dialog.vala"
	block4_data_unref (_data4_);
#line 272 "../games/scores/dialog.vala"
	_data4_ = NULL;
#line 2014 "dialog.c"
}

static void
games_scores_dialog_make_remaining_labels_empty (GamesScoresDialog* self,
                                                 gint row_count)
{
#line 327 "../games/scores/dialog.vala"
	g_return_if_fail (self != NULL);
#line 2023 "dialog.c"
	{
		gint i = 0;
#line 329 "../games/scores/dialog.vala"
		i = row_count;
#line 2028 "dialog.c"
		{
			gboolean _tmp0_ = FALSE;
#line 329 "../games/scores/dialog.vala"
			_tmp0_ = TRUE;
#line 329 "../games/scores/dialog.vala"
			while (TRUE) {
#line 2035 "dialog.c"
				GtkStack* stack = NULL;
				GtkGrid* _tmp8_;
				GtkWidget* _tmp9_;
				GtkStack* _tmp10_;
				GtkLabel* label = NULL;
				GtkStack* _tmp11_;
				GtkWidget* _tmp12_;
				GtkLabel* _tmp13_;
				GtkLabel* _tmp14_;
#line 329 "../games/scores/dialog.vala"
				if (!_tmp0_) {
#line 2047 "dialog.c"
					gint _tmp1_;
#line 329 "../games/scores/dialog.vala"
					_tmp1_ = i;
#line 329 "../games/scores/dialog.vala"
					i = _tmp1_ + 1;
#line 2053 "dialog.c"
				}
#line 329 "../games/scores/dialog.vala"
				_tmp0_ = FALSE;
#line 329 "../games/scores/dialog.vala"
				if (!(i <= self->priv->rows_to_display)) {
#line 329 "../games/scores/dialog.vala"
					break;
#line 2061 "dialog.c"
				}
				{
					gint j = 0;
#line 331 "../games/scores/dialog.vala"
					j = 0;
#line 2067 "dialog.c"
					{
						gboolean _tmp2_ = FALSE;
#line 331 "../games/scores/dialog.vala"
						_tmp2_ = TRUE;
#line 331 "../games/scores/dialog.vala"
						while (TRUE) {
#line 2074 "dialog.c"
							GtkLabel* label = NULL;
							GtkGrid* _tmp4_;
							GtkWidget* _tmp5_;
							GtkLabel* _tmp6_;
							GtkLabel* _tmp7_;
#line 331 "../games/scores/dialog.vala"
							if (!_tmp2_) {
#line 2082 "dialog.c"
								gint _tmp3_;
#line 331 "../games/scores/dialog.vala"
								_tmp3_ = j;
#line 331 "../games/scores/dialog.vala"
								j = _tmp3_ + 1;
#line 2088 "dialog.c"
							}
#line 331 "../games/scores/dialog.vala"
							_tmp2_ = FALSE;
#line 331 "../games/scores/dialog.vala"
							if (!(j <= 1)) {
#line 331 "../games/scores/dialog.vala"
								break;
#line 2096 "dialog.c"
							}
#line 333 "../games/scores/dialog.vala"
							_tmp4_ = self->priv->grid;
#line 333 "../games/scores/dialog.vala"
							_tmp5_ = gtk_grid_get_child_at (_tmp4_, j, i);
#line 333 "../games/scores/dialog.vala"
							_tmp6_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp5_, gtk_label_get_type (), GtkLabel));
#line 333 "../games/scores/dialog.vala"
							label = _tmp6_;
#line 334 "../games/scores/dialog.vala"
							_tmp7_ = label;
#line 334 "../games/scores/dialog.vala"
							gtk_label_set_text (_tmp7_, "");
#line 331 "../games/scores/dialog.vala"
							_g_object_unref0 (label);
#line 2112 "dialog.c"
						}
					}
				}
#line 337 "../games/scores/dialog.vala"
				_tmp8_ = self->priv->grid;
#line 337 "../games/scores/dialog.vala"
				_tmp9_ = gtk_grid_get_child_at (_tmp8_, 2, i);
#line 337 "../games/scores/dialog.vala"
				_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp9_, gtk_stack_get_type (), GtkStack));
#line 337 "../games/scores/dialog.vala"
				stack = _tmp10_;
#line 338 "../games/scores/dialog.vala"
				_tmp11_ = stack;
#line 338 "../games/scores/dialog.vala"
				_tmp12_ = gtk_stack_get_visible_child (_tmp11_);
#line 338 "../games/scores/dialog.vala"
				_tmp13_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_tmp12_, gtk_label_get_type (), GtkLabel));
#line 338 "../games/scores/dialog.vala"
				label = _tmp13_;
#line 339 "../games/scores/dialog.vala"
				_tmp14_ = label;
#line 339 "../games/scores/dialog.vala"
				gtk_label_set_text (_tmp14_, "");
#line 329 "../games/scores/dialog.vala"
				_g_object_unref0 (label);
#line 329 "../games/scores/dialog.vala"
				_g_object_unref0 (stack);
#line 2140 "dialog.c"
			}
		}
	}
}

static void
games_scores_dialog_class_init (GamesScoresDialogClass * klass,
                                gpointer klass_data)
{
#line 24 "../games/scores/dialog.vala"
	games_scores_dialog_parent_class = g_type_class_peek_parent (klass);
#line 24 "../games/scores/dialog.vala"
	g_type_class_adjust_private_offset (klass, &GamesScoresDialog_private_offset);
#line 24 "../games/scores/dialog.vala"
	G_OBJECT_CLASS (klass)->finalize = games_scores_dialog_finalize;
#line 2156 "dialog.c"
}

static void
games_scores_dialog_instance_init (GamesScoresDialog * self,
                                   gpointer klass)
{
#line 24 "../games/scores/dialog.vala"
	self->priv = games_scores_dialog_get_instance_private (self);
#line 27 "../games/scores/dialog.vala"
	self->priv->active_category = NULL;
#line 28 "../games/scores/dialog.vala"
	self->priv->rows_to_display = 10;
#line 30 "../games/scores/dialog.vala"
	self->priv->combo = NULL;
#line 31 "../games/scores/dialog.vala"
	self->priv->category_label = NULL;
#line 32 "../games/scores/dialog.vala"
	self->priv->headerbar = NULL;
#line 2175 "dialog.c"
}

static void
games_scores_dialog_finalize (GObject * obj)
{
	GamesScoresDialog * self;
#line 24 "../games/scores/dialog.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, GAMES_SCORES_TYPE_DIALOG, GamesScoresDialog);
#line 26 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->context);
#line 27 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->active_category);
#line 30 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->combo);
#line 31 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->category_label);
#line 32 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->headerbar);
#line 33 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->grid);
#line 36 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->new_high_score);
#line 37 "../games/scores/dialog.vala"
	_g_object_unref0 (self->priv->scores_active_category);
#line 24 "../games/scores/dialog.vala"
	G_OBJECT_CLASS (games_scores_dialog_parent_class)->finalize (obj);
#line 2202 "dialog.c"
}

static GType
games_scores_dialog_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GamesScoresDialogClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) games_scores_dialog_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GamesScoresDialog), 0, (GInstanceInitFunc) games_scores_dialog_instance_init, NULL };
	GType games_scores_dialog_type_id;
	games_scores_dialog_type_id = g_type_register_static (gtk_dialog_get_type (), "GamesScoresDialog", &g_define_type_info, 0);
	GamesScoresDialog_private_offset = g_type_add_instance_private (games_scores_dialog_type_id, sizeof (GamesScoresDialogPrivate));
	return games_scores_dialog_type_id;
}

GType
games_scores_dialog_get_type (void)
{
	static volatile gsize games_scores_dialog_type_id__once = 0;
	if (g_once_init_enter (&games_scores_dialog_type_id__once)) {
		GType games_scores_dialog_type_id;
		games_scores_dialog_type_id = games_scores_dialog_get_type_once ();
		g_once_init_leave (&games_scores_dialog_type_id__once, games_scores_dialog_type_id);
	}
	return games_scores_dialog_type_id__once;
}

